import re
import string

def jsClean(self,js):
  """ eliminate //comments and /* comments */ """ 
  clean = []
  comment=re.compile(r"^//")
  block=re.compile(r"/\*.*?\*/", re.S)
  js=block.sub('',js)
  js=string.split(js,'\n')
  for line in js:
    ln=string.strip(line)
    if ln=='' or comment.search(ln):
      pass
    else:
      clean.append(line)
  return string.join(clean,'\n')

def jsSafe(self,s):
  """ make string safe to be a JavaScript variable name """
  REQUEST=self.REQUEST
  safe=string.letters + string.digits + '_'
  res=list(s)
  for i in range(len(res)):
    c=res[i]
    if c not in safe:
        res[i]='%%%02x' % ord(c)
  sSafe=string.joinfields(res, '')
  sSafe=string.replace(sSafe,'%','_')
  return sSafe

