__doc__ = """ ActiveImages Product """
__version__='4.0'

from ImageFile import ImageFile

import ActiveImages
import ActiveImage

# Product meta-data (Names of objects added by this product)
meta_types=(
  {'name':'ActiveImages','action':'manage_addActiveImagesForm'},
)

# Attributes (usually "methods") to be added to folders to support
methods={
  # creating objects
  'manage_addActiveImagesForm': ActiveImages.addActiveImagesForm,
  'manage_addActiveImages': ActiveImages.addActiveImages,
  'manage_addActiveImageForm': ActiveImage.addActiveImageForm,
  'manage_addActiveImage': ActiveImage.addActiveImage,
  }

# Permission to be added to folders:
__ac_permissions__=(

  # To add items:
  ('Add ActiveImagess', ('manage_addActiveImagesForm','manage_addActiveImages') ),
  ('Add ActiveImages', ('manage_addActiveImageForm','manage_addActiveImage') ),

  # To manipulate item permissions at a high level.  Note that the
  # list of objects is empty, since we are just providing a place
  # to put acquired settings:
  ('Change ActiveImagess', ()),

  )

# Shared objects: <dtml-var SCRIPT_NAME>/misc_/Product/name
misc_={
  'ActiveImages': ImageFile('images/ActiveImagesIcon.gif',globals()),
  'ActiveImage': ImageFile('images/ActiveImageIcon.gif',globals()),
  'chooserIcon': ImageFile('images/chooserIcon.gif',globals()),
  }

def initialize (context):

  # Import help
  #if hasattr(context,'registerHelp'):
  #  context.registerHelp()
  pass


